package com.valtech.gwt.client;

import java.util.ArrayList;
import java.util.List;

import com.google.gwt.user.client.ui.FlexTable;

/**
 * 
 * @author anthony.dahanne
 * 
 *         Cette classe propose des méthodes de manipulation sur les offres
 *         d'emploi
 * 
 */
public class RechercheOffresEmploi {

	/**
	 * Prend en paramètre un metier et une liste d'offres d'emploi, et ressort
	 * les offres d'emploi qui correspondent au métier parmi celles en entrée
	 * 
	 * @param metier
	 * @param offresEmploi
	 * @return liste d'offres d'emploi
	 */
	static public List<OffreEmploi> chercherOffresCorrespondantes(
			String metier, List<OffreEmploi> offresEmploi) {

		List<OffreEmploi> offresCorespondantes = new ArrayList<OffreEmploi>();
		if (metier != null) {
			for (OffreEmploi offreEmploi : offresEmploi) {
				if (metier.equals(offreEmploi.getMetier())) {
					offresCorespondantes.add(offreEmploi);
				}
			}
		}
		return offresCorespondantes;

	}

	/**
	 * Cree et remplit une FlexTable à partir d'une liste d'offres d'emploi
	 * 
	 * @param offresEmploi
	 * @return FlexTable remplit d'offres d'emploi
	 */
	static public FlexTable remplirTableauAvecOffres(
			List<OffreEmploi> offresEmploi) {
		// le tableau des resultats
		FlexTable tableauDesResultats = new FlexTable();

		int ligne = 0;
		for (OffreEmploi offreEmploi : offresEmploi) {
			tableauDesResultats.insertRow(ligne);
			tableauDesResultats.addCell(ligne);
			tableauDesResultats.addCell(ligne);
			tableauDesResultats.addCell(ligne);
			tableauDesResultats.setHTML(ligne, 0, offreEmploi.getMetier());
			tableauDesResultats.setHTML(ligne, 1, offreEmploi.getLangage());
			tableauDesResultats.setHTML(ligne, 2, offreEmploi.getDescription());
			ligne++;
		}

		return tableauDesResultats;

	}
}
