package com.valtech.gwt.client;

import java.util.ArrayList;
import java.util.List;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FormPanel;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.Panel;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class ApplicationRh implements EntryPoint {

	static RootPanel rootPanel = RootPanel.get();

	/**
	 * This is the entry point method.
	 */
	public void onModuleLoad() {

		// la liste des offres d'emploi
		final List<OffreEmploi> offresEmploi = new ArrayList<OffreEmploi>();
		offresEmploi.add(new OffreEmploi("Programmeur", "Java",
				"on recherche un développeur Agile"));
		offresEmploi.add(new OffreEmploi("Programmeur", "Ruby",
				"on recherche un développeur Agile"));
		offresEmploi.add(new OffreEmploi("Analyste", "Aucun en particulier",
				"On recherche un analyste expert en Fitness"));
		offresEmploi.add(new OffreEmploi("Analyste", "Perl",
				"On recherche un analyste expert en Selenium"));
		offresEmploi.add(new OffreEmploi("Chef de projet", "Python",
				"On recherche un Cdp qui sait développer en Python"));
		offresEmploi.add(new OffreEmploi("Chef de projet", "Java",
				"On recherche un Cdp qui sait développer en Java"));

		// creation du panneau de resultats
		final Panel resultatsPanel = new VerticalPanel();

		// creation de notre formulaire
		Panel formPanel = new FormPanel();
		// creation du panneau de contenu
		Panel panelDeContenu = new VerticalPanel();

		// selection de metiers
		Panel panelDesMetiers = new HorizontalPanel();
		Label metiersLabel = new Label("Métiers : ");
		final ListBox selectionMetier = new ListBox();
		selectionMetier.insertItem("Programmeur", 0);
		selectionMetier.insertItem("Analyste", 1);
		selectionMetier.insertItem("Chef de projet", 2);
		panelDesMetiers.add(metiersLabel);
		panelDesMetiers.add(selectionMetier);
		panelDeContenu.add(panelDesMetiers);

		// selection de langage de programmation
		// Panel panelDesLangages = new HorizontalPanel();
		// Label langagesLabel = new Label("Langages : ");
		// final CheckBox choixJava = new CheckBox("Java");
		// final CheckBox choixRuby = new CheckBox("Ruby");
		// final CheckBox choixPython = new CheckBox("Python");
		// panelDesLangages.add(langagesLabel);
		// panelDesLangages.add(choixJava);
		// panelDesLangages.add(choixRuby);
		// panelDesLangages.add(choixPython);
		// panelDeContenu.add(panelDesLangages);

		// recherche champ libre
		// Panel panelChampLibre = new HorizontalPanel();
		// Label champLibreLabel = new Label("Recherche Libre : ");
		// TextBox champLibre = new TextBox();
		// panelChampLibre.add(champLibreLabel);
		// panelChampLibre.add(champLibre);
		// panelDeContenu.add(panelChampLibre);

		// envoyer
		Button envoyer = new Button("Envoyer la demande");
		envoyer.addClickListener(new ClickListener() {

			public void onClick(Widget sender) {
				resultatsPanel.clear();
				String langageChoisi = new String();
				// if (choixJava.isChecked()) {
				// langageChoisi = choixJava.getName();
				// } else if (choixPython.isChecked()) {
				// langageChoisi = choixPython.getName();
				// } else if (choixRuby.isChecked()) {
				// langageChoisi = choixRuby.getName();
				// }
				List<OffreEmploi> offresTrouvees = RechercheOffresEmploi
						.chercherOffresCorrespondantes(
								selectionMetier.getItemText(selectionMetier
										.getSelectedIndex()), offresEmploi);
				// on remplit le tableau de resultats
				FlexTable tableauDesResultats = RechercheOffresEmploi
						.remplirTableauAvecOffres(offresTrouvees);
				tableauDesResultats.setBorderWidth(2);
				resultatsPanel.add(tableauDesResultats);
			}

		});
		panelDeContenu.add(envoyer);

		// ajout au formPanel de notre panel de contenu
		formPanel.add(panelDeContenu);
		// ajout au panel racine de notre panel formulaire
		rootPanel.add(formPanel);
		rootPanel.add(resultatsPanel);

	}
}
