package com.valtech.gwt.client;

import java.util.List;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.AbstractImagePrototype;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.FormPanel;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.HorizontalSplitPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.Panel;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;
import com.gwtext.client.widgets.grid.GridPanel;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class ApplicationRh implements EntryPoint {

	static RootPanel rootPanel = RootPanel.get();

	/**
	 * This is the entry point method.
	 */
	public void onModuleLoad() {

		// creation des bandeaux du module
		MyImageBundle monBundle = GWT.create(MyImageBundle.class);
		AbstractImagePrototype valtechImgPrototype = monBundle.valtech();
		AbstractImagePrototype logoImgPrototype = monBundle.logo();

		// creation du panneau de resultats
		final Panel resultatsPanel = new VerticalPanel();

		// appel au service RPC asynchrone
		// 1) parametrage de la callback
		final AsyncCallback<List<OffreEmploi>> callback = new AsyncCallback<List<OffreEmploi>>() {

			public void onFailure(Throwable caught) {
				CodesJSNI.alert("Erreur lors de l'appel distant !"
						+ caught.getLocalizedMessage());

			}

			public void onSuccess(List<OffreEmploi> result) {
				GridPanel flextable = CreateurBeauTableauDeResultats
						.remplitBeauTableauDeResultats(CreateurBeauTableauDeResultats
								.convertitListeOffresEnTableauOffres(result));
				resultatsPanel.add(flextable);
			}

		};

		// creation de notre formulaire
		Panel formPanel = new FormPanel();

		// creation du split panel
		Panel splitPanel = new HorizontalSplitPanel();
		splitPanel.setHeight("250px");
		splitPanel.add(formPanel);
		splitPanel.add(resultatsPanel);

		// creation du panneau de contenu
		Panel panelDeContenu = new VerticalPanel();

		// selection de metiers
		Panel panelDesMetiers = new HorizontalPanel();
		Label metiersLabel = new Label("Métiers : ");
		final ListBox selectionMetier = new ListBox();
		selectionMetier.insertItem("Programmeur", 0);
		selectionMetier.insertItem("Analyste", 1);
		selectionMetier.insertItem("Chef de Projet", 2);
		panelDesMetiers.add(metiersLabel);
		panelDesMetiers.add(selectionMetier);
		panelDeContenu.add(panelDesMetiers);

		// ajout au formPanel de notre panel de contenu
		formPanel.add(panelDeContenu);
		// envoyer
		Button envoyer = new Button("Envoyer la demande");
		envoyer.addClickListener(new ClickListener() {

			public void onClick(Widget sender) {
				// on nettoie le panel avant de le remplir de nouveau
				resultatsPanel.clear();

				// appel au service RPC asynchrone
				// 2) creation dynamique de la classe proxy
				OffresEmploiServiceAsync offresEmploiServiceProxy = GWT
						.create(OffresEmploiService.class);
				// 3) appel au service
				offresEmploiServiceProxy.getOffresEmploi(selectionMetier
						.getItemText(selectionMetier.getSelectedIndex()),
						callback);

			}

		});
		panelDeContenu.add(envoyer);

		// ajouts des panels à la racine
		rootPanel.add(logoImgPrototype.createImage());
		rootPanel.add(splitPanel);
		// rootPanel.add(resultatsPanel);
		rootPanel.add(valtechImgPrototype.createImage());
		rootPanel.setTitle("Appli RH !");
		rootPanel.addStyleName("root");

	}
}
