package com.valtech.gwt.client;

import java.util.List;

import com.gwtext.client.data.ArrayReader;
import com.gwtext.client.data.FieldDef;
import com.gwtext.client.data.MemoryProxy;
import com.gwtext.client.data.RecordDef;
import com.gwtext.client.data.Store;
import com.gwtext.client.data.StringFieldDef;
import com.gwtext.client.widgets.grid.ColumnConfig;
import com.gwtext.client.widgets.grid.ColumnModel;
import com.gwtext.client.widgets.grid.GridPanel;

public class CreateurBeauTableauDeResultats {

	public static GridPanel remplitBeauTableauDeResultats(Object[][] offres) {
		RecordDef recordDef = new RecordDef(new FieldDef[] {
				new StringFieldDef("metier"), new StringFieldDef("langage"),
				new StringFieldDef("description") });

		final GridPanel grid = new GridPanel();

		MemoryProxy proxy = new MemoryProxy(offres);

		ArrayReader reader = new ArrayReader(recordDef);
		Store store = new Store(proxy, reader);
		store.load();
		grid.setStore(store);

		ColumnConfig[] columns = new ColumnConfig[] {
				new ColumnConfig("Métier", "metier", 80, true, null, "metier"),
				new ColumnConfig("Langage", "langage", 80, true),
				new ColumnConfig("Description", "description", 340, true) };

		ColumnModel columnModel = new ColumnModel(columns);
		grid.setColumnModel(columnModel);

		grid.setFrame(true);
		grid.setStripeRows(true);
		grid.setAutoExpandColumn("metier");

		grid.setHeight(250);
		grid.setWidth(500);
		grid.setTitle("Tableau des résultats");

		return grid;

	}

	public static Object[][] convertitListeOffresEnTableauOffres(
			List<OffreEmploi> offresEmploiListe) {

		Object[][] offresEmploiTableau = new Object[offresEmploiListe.size()][3];
		int i = 0;
		for (OffreEmploi offreEmploi : offresEmploiListe) {
			offresEmploiTableau[i] = new Object[3];
			offresEmploiTableau[i][0] = offreEmploi.getMetier();
			offresEmploiTableau[i][1] = offreEmploi.getLangage();
			offresEmploiTableau[i][2] = offreEmploi.getDescription();
			i++;
		}

		return offresEmploiTableau;

	}
}